/* Filename: C17IN.C
   Program that builds an input string array
   using getchar() */
#include <stdio.h>
#define MAX 25                     // Size of character
                                   // array to be typed in
void main(void);
void getInStr(char str[], int len);


void main(void)
{
   char inputStr[MAX];  // Keyboard input will fill this
   printf("What is your full name? ");
   getInStr(inputStr, MAX);    // String from keyboard
   printf("After return, your name is %s", inputStr);
   return 0;
}

/******************************************************
The following function requires that a string and the
maximum length of the string be passed to it. It accepts
input from the keyboard, and sends keyboard input into
the string. Upon return, the calling routine has access
to the string.
*******************************************************/
void getInStr(char str[], int len)
{
   int i=0, inputChar;       // Index and character typed
   inputChar = getchar(); // Get next character in string
   while (i<(len-1) && (inputChar!='\n'))
     {
        str[i] = inputChar;      // Build the string, one
                                 //   character at a time
        i++;
        inputChar = getchar();            // Get the next
                              //  character in the string
     }
   str[i]='\0';      // Make the char array into a string
   return 0;
}
