/* Filename: C21ARPT2.C
   Comprehensive reference of arrays and pointers */
#include <stdio.h>
main()
{
   float ara[] = {100.0, 200.0, 300.0, 400.0, 500.0};
   float *fptr;                 // Floating-point pointer

   /* Make pointer point to array's first value */
   fptr = &ara[0];          // Could also have been this:
                            // fptr = ara;

   printf("%.1f \n", *fptr);              // Prints 100.0
   fptr++;         // Points to next floating-point value
   printf("%.1f \n", *fptr);              // Prints 200.0
   fptr++;         // Points to next floating-point value
   printf("%.1f \n", *fptr);              // Prints 300.0
   fptr++;         // Points to next floating-point value
   printf("%.1f \n", *fptr);              // Prints 400.0
   fptr++;         // Points to next floating-point value
   printf("%.1f \n", *fptr);              // Prints 500.0

   fptr = ara;           // Points to first element again
   printf("%.1f \n", *(fptr+2) );    // Prints 300.00 but
                                  // does not change fptr

/* References both array and pointer using subscripts  */
   printf("%.1f  %.1f \n", (fptr+0)[0],
           (ara+0)[0]);                   // 100.0  100.0
   printf("%.1f  %.1f \n", (fptr+1)[0],
           (ara+1)[0]);                   // 200.0  200.0
   printf("%.1f  %.1f \n", (fptr+4)[0],
           (ara+4)[0]);                   // 500.0  500.0

   /* References both array and pointer using subscripts.
      Notice that subscripts are based from addresses that
      begin before the data in the array and the pointer. */
   printf("%.1f  %.1f \n", (fptr[ms]1)[2],
           (ara[ms]1)[2]);                   // 200.0  200.0
   printf("%.1f  %.1f \n", (fptr[ms]20)[23],
           (ara[ms]20)[23]);                 // 400.0  400.0
   return 0;
}
