/* Filename: C23DSINV.C
   Data-entry program for a disk drive company */
#include <stdio.h>
#include <stdlib.h>

struct inventory            // Global structure definition
{
   long int storage;
   int accessTime;
   char vendorCode;
   float cost;
   float price;
};            // No structure variables defined globally

void dispMenu(void);
struct inventory enterData();
void seeData(struct inventory disk[125], int numItems);
void main(void);

void main(void)
{
struct inventory disk[125];   // Local array of structures
   int ans;
   int numItems=0;                // Number of total items
                                       // in the inventory

   do
     {
        do
         { dispMenu();    // Display menu of user choices
           scanf(" %d", &ans);       // Get user's request
         } while ((ans<1) || (ans>3));

         switch (ans)
      { case (1): { disk[numItems] = enterData(); // Enter
                                              // disk data
                 numItems++; // Increment number of items
                 break; }
        case (2): { seeData(disk, numItems);  // Display
                                              // disk data
                 break; }
        default : { break; }
      }
      }  while (ans!=3);           // Quit program
                                   // when user is through
     return 0;
}

void dispMenu(void)
{

   printf("\n\n*** Disk Drive Inventory System ***\n\n");
   printf("Do you want to:\n\n");
   printf("\t1. Enter new item in inventory\n\n");
   printf("\t2. See inventory data\n\n");
   printf("\t3. Exit the program\n\n");
   printf("What is your choice? ");
   return 0;
}

struct inventory enterData()
{
   struct inventory diskItem;   // Local variable to fill
                                //  with input

   printf("\n\nWhat is the next drive's storage in \
           mega bytes? ");
   scanf(" %ld", &diskItem.storage);
   printf("What is the drive's access time in ms? ");
   scanf(" %d", &diskItem.accessTime);
   printf("What is the drive's vendor code (A, B, C, \
           or D)? ");
   fflush(stdin);  /* Discard input buffer
                      before getting character */
   diskItem.vendorCode = getchar();
   getchar();  /* Discard carriage return */
   printf("What is the drive's cost? ");
   scanf(" %f", &diskItem.cost);
   printf("What is the drive's price? ");
   scanf(" %f", &diskItem.price);

   return (diskItem);
}

void seeData(struct inventory disk[125], int numItems)
{
   int ctr;
   printf("\n\nHere is the inventory listing:\n\n");
   for (ctr=0;ctr<numItems;ctr++)
      {
      printf("Megabyte storage: %ld\t", disk[ctr].storage);
      printf("Access time: %d\n", disk[ctr].accessTime);
      printf("Vendor code: %c\t", disk[ctr].vendorCode);
      printf("Cost: $%.2f\t", disk[ctr].cost);
      printf("Price: $%.2f\n", disk[ctr].price);
      }
   return 0;
}
