/* Filename: C23MAG.C
   Magazine inventory program for adding and displaying
   a bookstore's magazines */
#include <stdio.h>
#include <ctype.h>

struct magInfo
   { char title[25];
     char pub[25];
     int month;
     int year;
     int stockCopies;
     int orderCopies;
     float price;
   };

struct magInfo fillMags(struct magInfo mag);
void printMags(struct magInfo mags[], int magCtr);
void main(void);

void main(void)
{
   struct magInfo mags[1000];
   int magCtr=0;            /* Number of magazine titles */
   char ans;

   do
   {                      /* Assumes that there will be
                             at least one magazine filled */
      mags[magCtr] = fillMags(mags[magCtr]);
      printf("Do you want to enter another magazine? ");
      fflush(stdin);
      ans = getchar();
      fflush(stdin);           /* Discard carriage return */
      if (toupper(ans) == 'Y')
        { magCtr++; }
        } while (toupper(ans) == 'Y');
      printMags(mags, magCtr);
      return 0;               /* Return to operating system */
}

void printMags(struct magInfo mags[], int magCtr)
{
   int i;
   for (i=0; i<=magCtr; i++)
     { printf("\n\nMagazine %d:\n", i+1);   /* Adjust for
                                                subscript */
       printf("\nTitle: %s \n", mags[i].title);
       printf("\tPublisher: %s \n", mags[i].pub);
       printf("\tPub. Month: %d \n", mags[i].month);
       printf("\tPub. Year: %d \n", mags[i].year);
       printf("\tIn-stock: %d \n", mags[i].stockCopies);
       printf("\tOn order: %d \n", mags[i].orderCopies);
       printf("\tPrice: %.2f \n", mags[i].price);
     }
   return 0;
}

struct magInfo fillMags(struct magInfo mag)
{
   puts("\n\nWhat is the title? ");
   gets(mag.title);
   puts("Who is the publisher? ");
   gets(mag.pub);
   puts("What is the month (1, 2, ..., 12)? ");
   scanf(" %d", &mag.month);
   puts("What is the year? ");
   scanf(" %d", &mag.year);
   puts("How many copies in stock? ");
   scanf(" %d", &mag.stockCopies);
   puts("How many copies on order? ");
   scanf(" %d", &mag.orderCopies);
   puts("How much is the magazine? ");
   scanf(" %f", &mag.price);
   return (mag);
}

